/* Generated by re2c 0.14.3 on Wed Sep 29 20:04:37 2021 */
#line 1 "TRConfigLexer.re"
/*
 * TRConfigLexer.re vi:ts=4:sw=4:expandtab:
 * Configuration Lexer
 *
 * Author: Landon Fuller <landonf@threerings.net>
 *
 * Copyright (c) 2006 - 2007 Three Rings Design, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of any contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#import <config.h>
#endif

#import <stdio.h>
#import <assert.h>
#import <sys/types.h>
#import <sys/stat.h>
#import <sys/mman.h>

#import "TRConfig.h"
#import "TRConfigLexer.h"
#import "TRConfigParser.h"

/*
 * re2c Configuration
 */
#define YYCTYPE     char        /* Input Symbol Type */
#define YYCURSOR    _cursor     /* L-expression of type *YYCTYPE that points to the current input symbol */
#define YYLIMIT     _limit      /* Expression of type *YYCTYPE that marks the end of the buffer */
#define YYMARKER    _marker     /* L-expression of type *YYCTYPE that is used for backtracking information */
#define YYCTXMARKER _ctxMarker  /* L-expression of type *YYCTYPE that is used for trailing context back tracking information */
#define YYFILL(n)   [self fill: n]  /* YYFILL(n) is called when the buffer needs (re)filling */

#define YYDEBUG(state, current) printf("state: %d, current: '%c' (%d)\n", state, current, current);

/*
 * Macros
 */

/* Increment line count */
#define INCR_LINE()    _lineNumber++

/* Switch to a start condition */
#define BEGIN(cond)    ( _condition = LEXER_SC_ ## cond)

/* Declare a start condition */
#define SC(cond)    LEXER_SC_ ## cond: LEXER_SC_ ## cond

/* Check for end-of-input */
#define CHECK_EOI()    if (_eoi) { return NULL; }

/* Skip a token */
#define SKIP(cond)    CHECK_EOI(); goto LEXER_SC_ ## cond

/* Get the current token length */
#define TOKEN_LENGTH()    (_cursor - _token)

@implementation TRConfigLexer

- (void) dealloc {
    if (buffer)
        munmap(buffer, bufferLength);
    [super dealloc];
}

- (id) initWithFD: (int) fd {
    struct stat statbuf;

    /* Initialize */
    self = [self init];
    if (self == NULL)
        return (self);

    /* Mmap() source file
     * Unless our caller botched something, this should never fail */
    assert((fstat(fd, &statbuf) == 0));
    bufferLength = statbuf.st_size;
    buffer = mmap(NULL, bufferLength, PROT_READ, MAP_SHARED, fd, 0);
    assert(buffer != MAP_FAILED);

    /* Initialize lexer state */
    _lineNumber = 1;
    _condition = LEXER_SC_INITIAL;
    _cursor = buffer;
    _limit = _cursor + bufferLength - 1;

    return (self);
}

- (void) fill: (int) length {
    /* We just need to prevent re2c from walking off the end of our buffer */
    assert(_limit - _cursor >= 0);
    if (_cursor == _limit) {
        /* Save the cursor and signal EOI */
        _eoi = _cursor;
    }
}

- (TRConfigToken *) scan {
    TRConfigToken *token;
    #line 129 "TRConfigLexer.re"


    /* Test for EOI before scanning */
    CHECK_EOI();

    switch (_condition) {
        case SC(INITIAL):
            _token = _cursor;
            
#line 139 "TRConfigLexer.m"
{
	YYCTYPE yych;

	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy2;
	case '\n':	goto yy10;
	case '#':	goto yy4;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy6;
	case '<':	goto yy8;
	default:	goto yy12;
	}
yy2:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy19;
yy3:
#line 140 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 226 "TRConfigLexer.m"
yy4:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy17;
yy5:
#line 145 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 236 "TRConfigLexer.m"
yy6:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy15;
yy7:
#line 150 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_KEY];
                BEGIN(VALUE);
                return token;
            }
#line 251 "TRConfigLexer.m"
yy8:
	++YYCURSOR;
#line 160 "TRConfigLexer.re"
	{
                SKIP(SECTION);
            }
#line 258 "TRConfigLexer.m"
yy10:
	++YYCURSOR;
#line 165 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 266 "TRConfigLexer.m"
yy12:
	++YYCURSOR;
#line 171 "TRConfigLexer.re"
	{
                // TODO explode here
                printf("Unknown character: '%c' (%d)\n", yych, yych);
                return NULL;
            }
#line 275 "TRConfigLexer.m"
yy14:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy15:
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy14;
	default:	goto yy7;
	}
yy16:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy17:
	switch (yych) {
	case '\n':	goto yy5;
	default:	goto yy16;
	}
yy18:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy19:
	switch (yych) {
	case '\t':
	case ' ':	goto yy18;
	default:	goto yy3;
	}
}
#line 177 "TRConfigLexer.re"


            break;

        /* Section Declarations */
        case SC(SECTION):
            _token = _cursor;
            
#line 377 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy26;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy23;
	case '/':	goto yy25;
	default:	goto yy22;
	}
yy22:
yy23:
	YYCTXMARKER = YYCURSOR + 1;
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy32;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy23;
	case '>':	goto yy35;
	default:	goto yy22;
	}
yy25:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy22;
	default:	goto yy29;
	}
yy26:
	++YYCURSOR;
#line 217 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 540 "TRConfigLexer.m"
yy28:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy29:
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy28;
	case '>':	goto yy30;
	default:	goto yy22;
	}
yy30:
	++YYCURSOR;
#line 207 "TRConfigLexer.re"
	{
                /* Drop the leading '/' and trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token + 1
                                    numBytes: TOKEN_LENGTH() - 2
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_END];
                return token;
            }
#line 625 "TRConfigLexer.m"
yy32:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy32;
	default:	goto yy34;
	}
yy34:
	YYCURSOR = YYCTXMARKER;
#line 197 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                BEGIN(SECTION_NAME);
                return token;
            }
#line 646 "TRConfigLexer.m"
yy35:
	++YYCURSOR;
#line 187 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                return token;
            }
#line 658 "TRConfigLexer.m"
}
#line 222 "TRConfigLexer.re"


            break;

        case SC(SECTION_NAME):
            _token = _cursor;
            
#line 668 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy40;
	case '\n':	goto yy45;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy43;
	default:	goto yy39;
	}
yy39:
yy40:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy40;
	default:	goto yy42;
	}
yy42:
#line 230 "TRConfigLexer.re"
	{
                SKIP(SECTION_NAME);
            }
#line 758 "TRConfigLexer.m"
yy43:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy43;
	case '>':	goto yy47;
	default:	goto yy39;
	}
yy45:
	++YYCURSOR;
#line 246 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 838 "TRConfigLexer.m"
yy47:
	++YYCURSOR;
#line 235 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_NAME];
                BEGIN(INITIAL);
                return token;
            }
#line 851 "TRConfigLexer.m"
}
#line 251 "TRConfigLexer.re"


        /* Values */
        case SC(VALUE):
            _token = _cursor;
            
#line 860 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	case '\n':	goto yy62;
	case '"':	goto yy57;
	case '#':	goto yy54;
	default:	goto yy59;
	}
yy51:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	default:	goto yy53;
	}
yy53:
#line 257 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 887 "TRConfigLexer.m"
yy54:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':
	case '"':	goto yy64;
	case '\n':	goto yy56;
	default:	goto yy54;
	}
yy56:
#line 262 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 904 "TRConfigLexer.m"
yy57:
	++YYCURSOR;
#line 267 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 911 "TRConfigLexer.m"
yy59:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case ' ':
	case '"':	goto yy61;
	default:	goto yy59;
	}
yy61:
#line 272 "TRConfigLexer.re"
	{ /* " vim syntax fix */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 932 "TRConfigLexer.m"
yy62:
	++YYCURSOR;
#line 281 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 940 "TRConfigLexer.m"
yy64:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy56;
	default:	goto yy64;
	}
}
#line 286 "TRConfigLexer.re"

            break;

        /* Quoted string values */
        case SC(STRING_VALUE):
            _token = _cursor;

            
#line 959 "TRConfigLexer.m"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy74;
	case '"':	goto yy68;
	case '#':	goto yy69;
	default:	goto yy72;
	}
yy68:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy71;
	} else {
		goto yy75;
	}
yy69:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy72;
	case '"':	goto yy78;
	default:	goto yy69;
	}
yy71:
#line 296 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 993 "TRConfigLexer.m"
yy72:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy73:
	switch (yych) {
	case '"':	goto yy76;
	default:	goto yy72;
	}
yy74:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy73;
yy75:
#line 312 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 1013 "TRConfigLexer.m"
yy76:
	++YYCURSOR;
#line 302 "TRConfigLexer.re"
	{
                /* Skip the trailing '"' */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 1025 "TRConfigLexer.m"
yy78:
	yych = *++YYCURSOR;
	goto yy80;
yy79:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy80:
	switch (yych) {
	case '\n':	goto yy71;
	default:	goto yy79;
	}
}
#line 317 "TRConfigLexer.re"

            break;

        default:
            /* Impossible */
            assert(0);
    }

    /* Never reached */
    return nil;
}

@end
